# https://fedoraproject.org/wiki/Packaging:Haskell

%bcond_without ikiwiki

Name:           git-annex
Version:        5.20140717
Release:        12%{?dist}
Summary:        Manage files with git, without checking their contents into git

License:        GPLv3+
Url:            https://hackage.haskell.org/package/%{name}
Source0:        https://hackage.haskell.org/package/%{name}-%{version}/%{name}-%{version}.tar.gz
Patch0:         git-annex-default-flags.patch
Patch1:         git-annex-quvi.patch
Patch2:         git-annex-network-uri.patch
Patch3:         git-annex-5.20140717-Process-createPipe.patch
Patch4:         git-annex-defaultTimeLocale.patch
Patch5:         git-annex-5.20140717-QuickCheck.patch

BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros
# Begin cabal-rpm deps:
BuildRequires:  ghc-HTTP-devel
BuildRequires:  ghc-IfElse-devel
BuildRequires:  ghc-MissingH-devel
BuildRequires:  ghc-QuickCheck-devel
BuildRequires:  ghc-SHA-devel
BuildRequires:  ghc-SafeSemaphore-devel
BuildRequires:  ghc-aeson-devel
BuildRequires:  ghc-async-devel
BuildRequires:  ghc-bloomfilter-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-case-insensitive-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-cryptohash-devel
BuildRequires:  ghc-data-default-devel
BuildRequires:  ghc-dataenc-devel
BuildRequires:  ghc-dbus-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-dlist-devel
BuildRequires:  ghc-edit-distance-devel
BuildRequires:  ghc-exceptions-devel
BuildRequires:  ghc-extensible-exceptions-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-hinotify-devel
BuildRequires:  ghc-hslogger-devel
BuildRequires:  ghc-json-devel
BuildRequires:  ghc-monad-control-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-network-devel
BuildRequires:  ghc-old-locale-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-random-devel
BuildRequires:  ghc-regex-tdfa-devel
BuildRequires:  ghc-stm-devel
BuildRequires:  ghc-text-devel
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-unix-compat-devel
BuildRequires:  ghc-unix-devel
BuildRequires:  ghc-utf8-string-devel
BuildRequires:  ghc-uuid-devel
# End cabal-rpm deps
BuildRequires:  git
%if %{with ikiwiki}
BuildRequires:  ikiwiki
BuildRequires:  perl(Image::Magick)
%endif

Requires:       git

%description
Git-annex allows managing files with git, without checking the file contents
into git. While that may seem paradoxical, it is useful when dealing with files
larger than git can currently easily handle, whether due to limitations in
memory, time, or disk space.

Even without file content tracking, being able to manage files with git, move
files around and delete files with versioned directory trees, and use branches
and distributed clones, are all very handy reasons to use git. And annexed
files can co-exist in the same git repository with regularly versioned files,
which is convenient for maintaining documents, Makefiles, etc that are
associated with annexed files but that benefit from full revision control.

When a file is annexed, its content is moved into a key-value store, and a
symlink is made that points to the content. These symlinks are checked into git
and versioned like regular files. You can move them around, delete them, and so
on. Pushing to another git repository will make git-annex there aware of the
annexed file, and it can be used to retrieve its content from the key-value
store.

%if %{with ikiwiki}
%package docs
Summary:        %{summary}
Group:          Documentation
BuildArch:      noarch

%description docs
This package contains the documentation for %{name} in HTML format.
%endif

%prep
%setup -q
%patch0 -p1 -b .flags
%patch1 -p1 -b .quvi
%patch2 -p1 -b .net-uri
%patch3 -p1 -b .createPipe
%patch4 -p1 -b .defaultTimeLocale
%patch5 -p1 -b .quickcheck


%build
%ghc_bin_build

%if %{with ikiwiki}
make docs
%else
make git-annex.1 git-annex-shell.1
%endif


%install
%ghc_bin_install
ln -s %{name} %{buildroot}%{_bindir}/%{name}-shell

mkdir -p %{buildroot}%{_mandir}/man1
install -m 0644 git-annex.1 %{buildroot}%{_mandir}/man1
install -m 0644 git-annex-shell.1 %{buildroot}%{_mandir}/man1


%files
%doc COPYRIGHT README debian/changelog
%attr(755,root,root) %{_bindir}/%{name}
%{_bindir}/%{name}-shell
%{_mandir}/man1/git-annex.1*
%{_mandir}/man1/git-annex-shell.1*

%if %{with ikiwiki}
%files docs
%doc html/
%endif


%changelog
* Mon Jun 20 2016 Jens Petersen <petersen@redhat.com> - 5.20140717-12
- need network-uri
- patch for ambiguous createPipe in Utility.Process
- patch for ambiguous defaultTimeLocale
- disable quvi and tahoe for build with ghc8

* Tue Mar  8 2016 Jens Petersen <petersen@redhat.com> - 5.20140717-11
- rebuild

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 5.20140717-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Sat Aug 08 2015 Ben Boeckel <mathstuf@gmail.com> - 5.20140717-8
- rebuild for ghc-edit-distance and ghc-bloomfilter

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.20140717-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Thu Apr 09 2015 Richard W.M. Jones <rjones@redhat.com> - 5.20140717-6
- Bump release and rebuild because of ghc-dbus dependency.

* Thu Mar  5 2015 Jens Petersen <petersen@redhat.com> - 5.20140717-5
- rebuild

* Tue Jan 27 2015 Jens Petersen <petersen@redhat.com> - 5.20140717-4
- cblrpm refresh

* Fri Sep  5 2014 Jens Petersen <petersen@redhat.com> - 5.20140717-3
- rebuild

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.20140717-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Wed Jul 23 2014 Ben Boeckel <mathstuf@gmail.com> - 5.20140717-1
- Update to 5.20140717
- disable DesktopNotify until fdo-notify packaged

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.20140221-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed Mar 26 2014 Ben Boeckel <mathstuf@gmail.com> - 5.20140221-2
- Rebuild for dbus rebuild

* Tue Feb 25 2014 Jens Petersen <petersen@redhat.com> - 5.20140221-1
- update to 5.20140221
- BR cryptohash

* Fri Feb 07 2014 Jens Petersen <petersen@redhat.com> - 5.20140116-1
- update to 5.20140116

* Wed Jan 22 2014 Jens Petersen <petersen@redhat.com> - 5.20140108-2
- rebuild

* Tue Jan 14 2014 Jens Petersen <petersen@redhat.com> - 5.20140108-1
- update to 5.20140108

* Tue Jan 14 2014 Jens Petersen <petersen@redhat.com> - 4.20130827-2
- enable dbus

* Wed Sep 04 2013 Jens Petersen <petersen@redhat.com> - 4.20130827-1
- update to 4.20130827
- update deps and default flags
- build with regex-tdfa

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.20130207-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jun 12 2013 Jens Petersen <petersen@redhat.com> - 3.20130207-1
- update to 3.20130207
- requires SafeSemaphore

* Thu Jun  6 2013 Jens Petersen <petersen@redhat.com> - 3.20121009-5
- IfElse is now in Fedora

* Fri Mar 22 2013 Jens Petersen <petersen@redhat.com> - 3.20121009-4
- rebuild

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.20121009-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Tue Dec 11 2012 Jens Petersen <petersen@redhat.com> - 3.20121009-2
- create manpages when no ikiwiki

* Tue Nov 06 2012 Jens Petersen <petersen@redhat.com> - 3.20121009-1
- update to 3.20121009

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.20120615-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Jun 26 2012 Jens Petersen <petersen@redhat.com> - 3.20120615-2
- fix doc file symlinks
- BR ImageMagick-perl
- make docs subpackage noarch

* Sat Jun 23 2012 Ben Boeckel <mathstuf@gmail.com> - 3.20120615-1
- Update to 3.20120615

* Tue May 22 2012 Jens Petersen <petersen@redhat.com> - 3.20120522-1
- create git-annex-shell symlink
- build and include manpages and docs in a subpackage

* Sat Apr 21 2012 Ben Boeckel <mathstuf@gmail.com> - 3.20120418-1
- Update to 3.20120418

* Fri Mar 02 2012 Ben Boeckel <mathstuf@gmail.com> - 3.20120229-1
- Update to 3.20120229

* Fri Mar  2 2012 Fedora Haskell SIG <haskell-devel@lists.fedoraproject.org>
- spec file template generated by cabal2spec-0.25.4
